#!/bin/bash
# lastact: arturo@2023-0220
# desc: reseteamos la cuenta de usuario de invitado

function crear_usuario_invitado() {
	_USU="${DATOS}"
	NOMBRE="$(jq -r ".nombre" <<<"${_USU}")"
	getent passwd "${NOMBRE}" >/dev/null 2>&1 &&
		echo "=> El usuario ${NOMBRE} ya existe en el sistema." && return 0
	USUID="$(jq -r ".uid" <<<"${_USU}")"
	COMENTARIO="$(jq -r ".comentario" <<<"${_USU}")"
	GPRIMARIO="$(jq -r '."grupo-primario"' <<<"${_USU}")"
	GSECUNDARIOS="$(jq -r '."grupos-secundarios"' <<<"${_USU}")"
	USUSHELL="$(jq -r ".shell" <<<"${_USU}")"
	USUHOME="$(jq -r ".home" <<<"${_USU}")"
	PASSWORD="$(jq -r ".password" <<<"${_USU}")"
	PLAIN="$(jq -r ".plain" <<<"${_USU}")"
	"${PLAIN}" && USUPASS="$(echo -n "${PASSWORD}" | mkpasswd -s -m sha-512)" || USUPASS="${PASSWORD}"
	useradd -m -d "${USUHOME}" \
		-c "${COMENTARIO}" \
		-u "${USUID}" \
		-g "${GPRIMARIO}" \
		-G "${GSECUNDARIOS}" \
		-s "${USUSHELL}" \
		-p "${USUPASS}" "${NOMBRE}" && return 0 || return 1
}

# Preparamos la auditoria:
FICHFUNCS="/usr/bin/vx-funcs-bash"
[ -f "${FICHFUNCS}" ] && . "${FICHFUNCS}" "null"

LOG="vx-invitado-reset.log"
vx-log_xsession -o "${LOG}"

# Eliminamos y volvemos a crear las cuentas de usuario del grupo invitados para resetearlas:
FICHJSON="/usr/share/vitalinux/jsons/vx-users-groups.json"
USUARIOS=( $(members "invitados") )
for USU in "${USUARIOS[@]}"; do
	# Eliminamos la cuenta de usuario:
	getent passwd "${USU}" && \
	{
		userdel -fr "${USU}" && \
		echo "Se ha eliminado la cuenta de usuario: \"${USU}\"" ;
	} || echo "No existe ninguna cuenta \"${USU}\" que eliminar"
	# Creamos la cuenta de usuario:
	DATOS="$(jq -c '.usuarios[] | select(.nombre == "'"${USU}"'")' "${FICHJSON}")"
crear_usuario_invitado "${DATOS}" && \
	echo "$(date) - Se ha creado la cuenta de ${USU}" || \
	echo "$(date) - Algún problema ha surgido al crear la cuenta de usuario: ${USU}"
done
